/****************************************************************************

2008/10/14 - version 10 - Random Fractal Mountain Generator by Steven & Hannes

****************************************************************************/

#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <math.h>
#include <GL/MTRand.h>
#include <windows.h>
#include <GL/glut.h>
#include <GL/glui.h>


int		main_window;
int		maxLevel			= 4; //start with level 4
int     depthBoxNr			= 4;
int		modelB				= 2; //start with piramid
int		modelBoxNr			= 2; 
int		randB				= 1;
int		vertexid			= 0;
int		auto_rotate			= 1; //start with rotate on
int		wire_surface		= 1; //start with wire body

float	xy_aspect;
float   dampeningBoxNr		= 2.0; //start with dampening 2 (default), randomvariation now decreases with 2^level. 
float	dampening			= 2.0;
float	maxAmplitudeNr		= 2.5; //start with amplitude 2.5, amplitude defines the random range, ie. [-amplitude - amplitude] 
float	maxAmplitude		= 2.5; 
float	minRange			= -1.0;
float	maxRange			= 1.0;
float	scale				= 1.0;
float	autoResizeFactor	= 0.0;
float	x					= 0.0; 
float	y					= 0.0;
float	z					= 0.0;
float	frustX =16.0, frustY=16.0, frustZN= 1, frustZF= 100;  
float	view_rotate[16]		= { 1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,1 };
float	rotateAboutX[16]	= { 1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,1 };
float	rotateAboutY[16]	= { 1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,1 };
float	rotateAboutZ[16]	= { 1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,1 };

bool	maxSizeReached = false;
bool	minSizeReached = true;
bool	maxAboutXReached = false;
bool	minAboutXReached = true;

GLfloat COPx=8,	COPy= 8,	COPz=8;
GLfloat	VRPx= 0.0,	VRPy = 0.0, VRPz= -1.0;
GLfloat VUVx=0.0,	VUVy=1.0,	VUVz= 0.0; 

MTRand rnd;
GLUI *glui;

/********** UI control ID definitions for callbacks and PI define ********/

#define ZOOMIN_ID			101
#define ZOOMOUT_ID			102
#define CHECK_ROTATE_ID		103
#define MODELBOX_ID			104
#define DEPTHBOX_ID			105
#define DAMPENINGBOX_ID		107
#define CHECK_WIRESRF_ID	108
#define RANDBOX_ID			109
#define	MAXAMPLITUDEBOX_ID	110
#define VIEW_ROTATE_ID		111
#define PI					3.14159

//point datastructure
typedef struct
{
	GLfloat x;
	GLfloat y;
	GLfloat z;
}Point;
void control_cb( int control )
{
	switch(control){
		case CHECK_ROTATE_ID: {	
			for (int i=0;i<16;i++)
			{
				if ((i==0)|(i==5)|(i==10)|(i==15))
					view_rotate[i] =  1;
				else
					view_rotate[i] =  0;
			}
			autoResizeFactor = 0.0;
			maxSizeReached = false;
			minSizeReached = true;
			maxAboutXReached = false;
			minAboutXReached = true;

			//reset rotatietabel
			x=0.0;
			y=0.0;
			z=0.0;
		} break;
		case DEPTHBOX_ID: {	
		  maxLevel = depthBoxNr;
		} break;
		case ZOOMIN_ID: {	
		  COPx--;
		  COPy--;
		  COPz--;
		} break;
		case ZOOMOUT_ID: {	
		  COPx++;
		  COPy++;
		  COPz++;
		} break;
		case DAMPENINGBOX_ID:	  {
			dampening = dampeningBoxNr;
		} break;
		case MODELBOX_ID:	  {	
			modelB = modelBoxNr;	
		} break;
		case MAXAMPLITUDEBOX_ID:	  {	
			maxAmplitude = maxAmplitudeNr;	
		} break;
		
		default: { 
			//niets
		}
	}
}

void myGlutReshape( int x, int y )
{
  int tx, ty, tw, th;
  GLUI_Master.get_viewport_area( &tx, &ty, &tw, &th );
  glViewport( tx, ty, tw, th );

  xy_aspect = (float)tw / (float)th;

  glutPostRedisplay();
}

GLuint LoadTextureRAW( const char * filename, int wrap )
{
	// load a 256x256 RGB .RAW file as a texture

    GLuint texture;
    int width, height;
    char * data;
    FILE * file;

    // open texture data
    file = fopen( filename, "rb" );
    if ( file == NULL ) return 0;

    // allocate buffer
    width = 256;
    height = 256;
    data = (char*)malloc( width * height * 3 );

    // read texture data
    fread(data, width * height * 3, 1, file );
    fclose( file );

    // allocate a texture name
    glGenTextures( 1, &texture );

    // select our current texture
    glBindTexture( GL_TEXTURE_2D, texture );

    // select modulate to mix texture with color for shading
    glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );

    // when texture area is small, bilinear filter the closest mipmap
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_NEAREST );
    // when texture area is large, bilinear filter the first mipmap
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );

    // if wrap is true, the texture wraps over at the edges (repeat)
    //       ... false, the texture ends at the edges (clamp)
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S,  wrap ? GL_REPEAT : GL_CLAMP );
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T,  wrap ? GL_REPEAT : GL_CLAMP );

    // build our texture mipmaps
    gluBuild2DMipmaps( GL_TEXTURE_2D, 3, width, height, GL_RGB, GL_UNSIGNED_BYTE, data );

    // free buffer
    free( data );

    return texture;
}



void setLights(){
	/* lichtpunt 1 */
	
	GLfloat lightPosition1[4] =			{7, 7, 7, 1.0};
	GLfloat lightColour[4]	  =			{ 1.0,  1.0, 1.0, 0.0 };
	glLightfv(GL_LIGHT0, GL_POSITION, lightPosition1);
	glLightfv(GL_LIGHT0, GL_AMBIENT, lightColour);

	//Enable lighting, shading, normalize
	glEnable(GL_NORMALIZE);
	glShadeModel(GL_SMOOTH);
	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHTING);
}
Point findMidPoint(Point p, Point q){
	Point mid;
	mid.x = (p.x+q.x)/2;
	mid.y = (p.y+q.y)/2;
	mid.z = (p.z+q.z)/2;
	return mid;
}

Point getRandomVariant(Point p, int level)
{

	/*	if   0 < dampening <1 then , then random variation grows when levels get up. Get you spikes in later levels (not very natural) 
		if	 dampening =1 , gets you a fixed random variation, producing not very realistic mountains/landscapes.
		if	 1 < dampening < +15(set upper limit) , then largest random variation is in first levels and goes rapidly to zero (default = 2)
	*/
	float dampeningFormula= (1.0/pow(dampening,level));
	float randomValue; 
	float punt1 = (pow((float)10,(float)6))*(float)p.x; //the first part is a trick to make sure almost complete randomness is assured
	float punt2 = (pow((float)10,(float)3))*(float)p.y; //although its not really neccesary, since its hardly noticable on high levels :D
	float punt3 = (pow((float)10,(float)-1))*(float)p.z;

	float seeder =	punt1 + punt2 + punt3; 

	rnd.seed(seeder); // initiele seed value

	float randomPos_or_neg = rnd.rand(1); //float tussen 0 en 1
	
	if (randomPos_or_neg <0.5){
		randomPos_or_neg = -1.0; //negatief
	}
	else
		randomPos_or_neg = 1.0; //positief

	randomValue = randomPos_or_neg * rnd.rand(maxAmplitude);
	randomValue = randomValue * dampeningFormula;

	//p.x	=	p.x		+	randomValue; //no random variation in x direction
	p.y	=	p.y		+	randomValue;
	//p.z	=	p.z		+	randomValue; //no random variation in z direction

	return p;
}

Point mapTexture(Point p){
	// mapping between world coords and texture
	Point textco;
	textco.x = p.x/10 + 0.5;
	textco.y = 0;
	textco.z = p.z/10 + 0.5;
	return textco;
}
Point getNormalVector(Point p, Point q, Point r){
	Point nv;
	Point s;
	Point t;

	//s = q-p;
	s.x = q.x-p.x;
	s.y = q.y-p.y;
	s.z = q.z-p.z;

	//t = q-r;
	t.x = r.x-q.x;
	t.y = r.y-q.y;
	t.z = r.z-q.z;

	//nv = (s x t); doesnt need normalizing
	nv.x = ((s.y*t.z) - (s.z*t.y)); 
	nv.y = ((s.z*t.x) - (s.x*t.z));
	nv.z = ((s.x*t.y) - (s.y*t.x));

	return nv;
}
void drawMountain(int level, Point p1, Point p2, Point p3 )
{
	if (level == maxLevel)
	{
		//berekenen van normaalvector van vlak
		Point norm = getNormalVector(p1,p2,p3);
		
		if (wire_surface == 0)													// 0 == wire frame
		{
			glBegin(GL_LINE_LOOP);	
				glColor3f(1,1,1);
				glVertex3f(p1.x,p1.y,p1.z);
				glColor3f(1,1,1);
				glVertex3f(p2.x,p2.y,p2.z);
				glColor3f(1,1,1);
				glVertex3f(p3.x,p3.y,p3.z);
			glEnd();
		}
		else{	
			//texture procedure
			Point texco1 = mapTexture(p1); 
			Point texco2 = mapTexture(p2);
			Point texco3 = mapTexture(p3);

			glBegin(GL_TRIANGLES);												// 1 == full surface body
				glTexCoord2d(texco1.x,texco1.z);
				glNormal3f(norm.x, norm.y, norm.z);
				glVertex3f(p1.x,p1.y,p1.z);
				
				glTexCoord2d(texco2.x,texco2.z);
				glNormal3f(norm.x, norm.y, norm.z);
				glVertex3f(p2.x,p2.y,p2.z);

				glTexCoord2d(texco3.x,texco3.z);
				glNormal3f(norm.x, norm.y, norm.z);
				glVertex3f(p3.x,p3.y,p3.z);
			glEnd();
		}
	}
	else
	{
		Point mpA = findMidPoint(p1,p2);										// punt tussen hoekpunt 1 en 2
		Point mpB = findMidPoint(p2,p3);										// punt tussen hoekpunt 2 en 3
		Point mpC = findMidPoint(p1,p3);										// punt tussen hoekpunt 1 en 3

		Point newA = getRandomVariant(mpA, level);
		Point newB = getRandomVariant(mpB, level);
		Point newC = getRandomVariant(mpC, level);

		level = level +1;

		drawMountain(level,p1,newA,newC);										//top driehoek					invoer is MIDDEN, LINKS,  RECHTS
		drawMountain(level,newA,p2,newB);										//linker driehoek				invoer is MIDDEN, LINKS,  RECHTS
		drawMountain(level,newC,newB,p3);										//rechter driehoek				invoer is MIDDEN, LINKS,  RECHTS
		drawMountain(level,newB,newC,newA);									//midden driehoek				invoer is LINKS , MIDDEN, RECHTS
	}
}
void draw_mountainMode(void)
{
	Point p,q,r,s,t;

	if(modelB==1)
	{
		// draw one triangle
		p.x=0;		p.y=5;		p.z=0;
		q.x=0;		q.y=0;		q.z=5;
		r.x=5;		r.y=0;		r.z=0;
	 glDisable( GL_LIGHTING );
		glPushMatrix();
			drawMountain(0, p,q,r);			// alleen basis driehoek
		glPopMatrix();
	glEnable( GL_LIGHTING );
	}
	else if(modelB == 2)
	{
		// draw a pyramid
		p.x=0;		p.y=5;		p.z=0;
		q.x=0;		q.y=0;		q.z=5;
		r.x=5;		r.y=0;		r.z=0;
		s.x = 0;	s.y = 0;	s.z = -5;
		t.x = -5;	t.y = 0;	t.z = 0;

		glPushMatrix();
			drawMountain(0, p, q, r);			
		glPopMatrix();

		glPushMatrix();
			drawMountain(0,   p,    r,   s);
		glPopMatrix();

		glPushMatrix();
			drawMountain(0,   p,   s,    t); 
		glPopMatrix();

		glPushMatrix();
			drawMountain(0,   p,    t,   q); 
		glPopMatrix();
	}
	else if(modelB == 3)
	{
		// draw square consiting of 2 triangles, of course more triangles are possible but it will result in more computation

		p.x=-5;		p.y=0;		p.z=-5;
		q.x=-5;		q.y=0;		q.z=5;
		r.x=5;		r.y=0;		r.z=-5;
		s.x = 5;	s.y = 0;	s.z = 5;
		t.x = -5;	t.y = 0;	t.z = 0;

		glPushMatrix();
			drawMountain(0, p,q,r);			// alleen basis driehoek
		glPopMatrix();

		glPushMatrix();
			drawMountain(0,   q,s,r);			// alleen basis driehoek
		glPopMatrix();
	}
}
void draw_axes( float scale )
{
  glDisable( GL_LIGHTING );

  glPushMatrix();
  glScalef( scale, scale, scale );

  glBegin( GL_LINES );
 
  glColor3f( 1.0, 0.0, 0.0 );
  glVertex3f( .8f, 0.05f, 0.0 );  glVertex3f( 1.0, 0.25f, 0.0 ); /* Letter X */
  glVertex3f( 0.8f, .25f, 0.0 );  glVertex3f( 1.0, 0.05f, 0.0 );
  glVertex3f( 0.0, 0.0, 0.0 );  glVertex3f( 2.0, 0.0, 0.0 ); /* X axis      */

  glColor3f( 0.0, 1.0, 0.0 );
  glVertex3f( 0.0, 0.0, 0.0 );  glVertex3f( 0.0, 2.0, 0.0 ); /* Y axis      */

  glColor3f( 0.0, 0.0, 1.0 );
  glVertex3f( 0.0, 0.0, 0.0 );  glVertex3f( 0.0, 0.0, 2.0 ); /* Z axis    */
  glEnd();

  glPopMatrix();

  glEnable( GL_LIGHTING );
}


void draw_sun( float scale )
{
	glDisable( GL_LIGHTING );
		glPushMatrix();
			glTranslatef( 7, 7, 7 );
			glPushAttrib(GL_ALL_ATTRIB_BITS);

				glColor3f( 1, 1, 0 );
				glutSolidSphere( scale, 50, 50 );

			glPopAttrib();
		glPopMatrix();
	glEnable( GL_LIGHTING );

}
void autoResizeFunc (void) 
{
	//this function realises a modelscale increase of  -20% to +20%), sole raison d'etre is just for viewing pleasure :D
	if (autoResizeFactor > 0.2)
	{
		maxSizeReached = true;
		minSizeReached = false;
	}

	if (autoResizeFactor < -0.2)
	{
		minSizeReached = true;
		maxSizeReached = false;
	}

	if (maxSizeReached == true)
		autoResizeFactor = autoResizeFactor - .003;
	else
		autoResizeFactor = autoResizeFactor + .003;

	glScalef( scale+autoResizeFactor, scale+autoResizeFactor, scale+autoResizeFactor );
}

void autoRotateFunc (void)
{
	//this funtion realises a 360dgr modelrotation, sole raison d'etre is just for viewing pleasure :D
	y = y + .01*PI;
	if (y >= 2*PI)
		y = y - 2*PI;
	
	rotateAboutY[0] = cos(y);
	rotateAboutY[2] = -sin(y);
	rotateAboutY[8] = sin(y);
	rotateAboutY[10] = cos(y);

	glMultMatrixf( rotateAboutY );
	}

void myGlutDisplay( void ){
	glClearColor(0.0,0.0,0.0,0.0);
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	gluPerspective(60,xy_aspect,frustZN,frustZF);

	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();
	gluLookAt(COPx,COPy,COPz,VRPx,VRPy,VRPz,VUVx,VUVy,VUVz);

	if (auto_rotate == 1)
	{
		autoResizeFunc();
		autoRotateFunc();
	}
	glMultMatrixf( view_rotate );
	vertexid = 0;			//resets vertex ID when redrawing.

	draw_axes(.5f);			//draw world coordinate origin
	draw_sun(.4f);			//draw artificial sun (GL_LIGHT0 has same position)
	draw_mountainMode();	//draw mountain in selected mode

	glPushMatrix(); 
		setLights();		//set the lights and fix it on the "sun" position, so not under rotation influence.
	glPopMatrix();
	
	glutSwapBuffers(); 
}
void idle(void)
{
	glutSetWindow (main_window);
	glutPostRedisplay ();
	Sleep (50);
}

void main(int argc, char* argv[])
{
  /****************************************/
  /*   Initialize GLUT and create window  */
  /****************************************/

	glutInit(&argc, argv);
	glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );
	glutInitWindowPosition( 50, 50 );
	glutInitWindowSize( 800, 600 );

	main_window = glutCreateWindow( "Mountain Gen version 10 by Steven & Hannes" );

	glutDisplayFunc( myGlutDisplay );
	GLUI_Master.set_glutReshapeFunc( myGlutReshape );  
	GLUI_Master.set_glutSpecialFunc( NULL );

	/****************************************/
	/*          Enable z-buferring          */
	/****************************************/
	glEnable(GL_DEPTH_TEST);

	/****************************************/
	/*       Set up OpenGL texture          */
	/****************************************/

	glEnable( GL_TEXTURE_2D );
	LoadTextureRAW ( "mountain256.raw", 1);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT); 

	/****************************************/
	/*GLUI code om oa. UI controls te bouwen*/
	/****************************************/

	GLUI_Master.set_glutIdleFunc (idle);

	/*** Create the bottom subwindow ***/
	glui = GLUI_Master.create_glui_subwindow( main_window, GLUI_SUBWINDOW_BOTTOM );

	//kolom 1
	GLUI_Panel *viewPanel= glui->add_panel ("Viewing Controls",GLUI_PANEL_EMBOSSED);
	glui->add_button_to_panel( viewPanel, "Zoom in", ZOOMIN_ID, control_cb );
	glui->add_button_to_panel( viewPanel, "Zoom out", ZOOMOUT_ID, control_cb );
	new GLUI_Column( glui, false);

	//kolom 2
	GLUI_Panel *controlPanel= glui->add_panel ("Model Controls",GLUI_PANEL_EMBOSSED);
	glui->add_panel_to_panel(controlPanel,"",GLUI_PANEL_NONE);
	glui->add_checkbox_to_panel(controlPanel,"Auto rotate", &auto_rotate, CHECK_ROTATE_ID, control_cb );
	glui->add_checkbox_to_panel(controlPanel,"Wire/surface body", &wire_surface, CHECK_WIRESRF_ID, control_cb );
	glui->add_column_to_panel(controlPanel, false);
	GLUI_Rotation *view_rot = new GLUI_Rotation(controlPanel, "Manual rotate",view_rotate,VIEW_ROTATE_ID, control_cb );
	view_rot->set_spin(.95);
	new GLUI_Column( glui, false);

	//kolom 3
	GLUI_Panel *genPanel= glui->add_panel ("Mountain Generator",GLUI_PANEL_EMBOSSED);

	GLUI_Panel *step1Panel = glui->add_panel_to_panel(genPanel, "Step 1: Choose model",GLUI_PANEL_EMBOSSED);
	
	GLUI_Listbox *modelBox = new GLUI_Listbox(step1Panel, "Choose Model: ",&modelBoxNr ,MODELBOX_ID, control_cb );
	modelBox->add_item(1,"1 triangle ");
	modelBox->add_item(2,"2 pyramid ");
	modelBox->add_item(3,"3 landscape ");
	modelBox->set_int_val(2);

	glui->add_column_to_panel(genPanel, false);

	//kolom 3b
	GLUI_Panel *step2Panel = glui->add_panel_to_panel(genPanel, "Step 2: Modify parameters",GLUI_PANEL_EMBOSSED);
	GLUI_Spinner *depthBox = new GLUI_Spinner(step2Panel,"MAX Depth: ",GLUI_SPINNER_INT,&depthBoxNr ,DEPTHBOX_ID, control_cb );
	GLUI_Spinner *dampeningBox = new GLUI_Spinner(step2Panel,"Dampening: ",GLUI_SPINNER_FLOAT,&dampeningBoxNr ,DAMPENINGBOX_ID, control_cb );
	GLUI_Spinner *maxAmplitudeBox = new GLUI_Spinner(step2Panel,"MAX Amplitude: ",GLUI_SPINNER_FLOAT,&maxAmplitudeNr ,MAXAMPLITUDEBOX_ID, control_cb );

	depthBox->set_int_limits(0,8);
	depthBox->set_speed(0.4);

	dampeningBox->set_float_limits(0.01,5);
	dampeningBox->set_speed(1);

	maxAmplitudeBox->set_float_limits(0,10);
	maxAmplitudeBox->set_speed(3);

	/**** Regular GLUT main loop ****/
	glui->set_main_gfx_window( main_window );
	glutMainLoop();
}
